/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react';
import StatefulListContainer from './stateful-list-container.js';
import List from './list.js';

var defaultStateReducer = function defaultStateReducer(type, nextState) {
  return nextState;
};

function StatefulList(props) {
  return /*#__PURE__*/React.createElement(StatefulListContainer, props, function (componentProps) {
    return /*#__PURE__*/React.createElement(List, componentProps);
  });
}

StatefulList.defaultProps = {
  initialState: {
    items: []
  },
  stateReducer: defaultStateReducer
};
export default StatefulList;